﻿@{
    ViewData["Title"] = "Regulatory Documents";
    var additionalRoles = ViewBag.additionalRoles;
    bool hasComplianceRole = !string.IsNullOrEmpty(additionalRoles) ? additionalRoles.Contains(AdminRoleEnum.Compliance.ToString()) : false;
}
<div class="container">
    <div class="card">
        <div class="card-body">
            <div class="datatable datatable-bordered" id="firm_list"></div>
        </div>
    </div>
</div>
<div class="modal" id="RegulatoryDocumentUploadModal" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel" aria-hidden="true"></div>
@section scripts{
    <script>
        var regulatoryDatatable = function (e) {
            var id = e.data.id;
            var ktDataTablOptions = ktDataTableDefaultConfigOptions;
            ktDataTablOptions.source = `adviser/home/fetchregulatorydocuments?firmId=${id}`;
            window['sub_datatable_' + id] = $('<div/>').attr('id', `firm_list_${id}`).appendTo(e.detailCell).KTDatatable({
                data: ktDataTablOptions,
                columnFilter: true,
                columns: [
                    { field: 'id', title: '#', width: 85, filter: { maxlength: 5, additionalClasses: "numericOnly-no-placeholder" } },
                    { field: 'fileName', title: 'File Name', width: 430, filter: {} },
                    {
                        field: 'extension', title: 'File Type', sortable: false,  textAlign: 'center', width: 120, filter: { filterType: "select", additionalClasses: `filetype-filter-dropdown-${id}`, container: "fileType", size: 5 },
                        template: function (row) {
                            var extension = row.extension;
                            row.fileName = row.fileName.replace("'", "/");
                            var type = extension.includes("doc") ? "word" : extension.includes("xls") ? "excel" : extension.includes("csv") ? "csv" : extension.includes("ppt") ? "powerpoint" : extension.includes("pdf") ? "pdf" : row.contentType.includes("image") ? "image" : row.contentType.includes("audio") ? "audio" : row.contentType.includes("video") ? "video" : row.contentType.includes("text") ? "alt" : "";
                            var color = extension.includes("doc") ? "295497" : extension.includes("xls") || extension.includes("csv") ? "1f7244" : extension.includes("ppt") ? "d14424" : extension.includes("pdf") ? "cb0606" : row.contentType.includes("image") ? "26b99a" : row.contentType.includes("audio") ? "8950FC" : row.contentType.includes("video") ? "F64E60" : row.contentType.includes("text") ? "3699FF" : "008080";
                            var knownHtml = `<i class="fas fa-file${type.length > 0 ? "-" : ""}${type}" style="color:#${color};font-size: 30px;" data-toggle="tooltip" data-title="${extension.toUpperCase()}" id="icon-${row.id}"></i>`;
                            var unknownHtml = `<span class="fa-stack fa-1x" style="font-size:1.2em !important" data-toggle="tooltip" data-title="${extension.toUpperCase()}" id="icon-${row.id}">
                                                                        <i class="fa fa-file fa-stack-2x" style="color:#${color}"></i>
                                                                          <span class="fa fa-stack-1x">
                                                                              <span style="font-size:10px;color:white;font-family: 'Poppins';font-weight: normal;">
                                                                                  ${extension.toUpperCase()}
                                                                              </span>
                                                                        </span>
                                                                    </span>	`;
                            return `<a href="javascript:" onclick="clientFileDownload('documents/regulatory', '${row.fileName}',0,${row.id})">
                                                            ${type.length > 0 ? knownHtml : unknownHtml}
                                                            <i class="fas fa-arrow-down animated faa-falling ml-2 text-primary d-none" id="loader-${row.id}"></i>
                                                        </a>`;
                        }
                    },
                    {
                        field: 'fileSize', title: 'File Size', width: 80,
                        template: function (row) {
                            return humanFileSize(row.fileSize);
                        }
                    },
                    {
                        field: 'uploadedDate', title: 'Uploaded Date', sortable: 'desc', width: 125,
                        template: function (row) {
                            return getDataTableDateWithHtml(row.uploadedDate)
                        },
                    },
                    {
                        field: 'actions', title: 'Actions', width: 50, sortable: false, overflow: 'visible',
                        template: function (row) {
                            var html = `<button class="btn btn-sm btn-icon btn-regulatory-delete" data-toggle="tooltip" data-original-title="Delete" data-guid="${row.guid}">
                                                                                                    <img src="/images/delete-icon.png" height="25" />
                                                                                                </button>`;
                            return html;
                        },
                    }
                ],
            })
            $(`#firm_list_${id}`).on('datatable-on-init', function (e, data) {
                bindfileTypeDropdown(id);
            });
        }
        var bindRegulatoryFirmsGrid = function (type, callback) {
            var ktDataTablOptions2 = ktDataTableDefaultConfigOptions;
            ktDataTablOptions2.source = 'admin/superadmin/fetchfirms';
            window['datatable'] = $('#firm_list').KTDatatable({
                data: ktDataTablOptions2,
                columnFilter: true,
                columns: [
                    { field: 'id', title: '', sortable: false, width: 0 },
                    {
                        field: 'firmName', title: 'Firm Name', sortable: 'asc', filter: { container: "FirmName" },
                        template: function (row) {
                            return `<div class="font-size-lg">${row.firmName}</div>`
                        }
                    },
                    {
                        field: `total`, title: '', textAlign: 'right', sortable: false, width: 50,
                        template: function (row) {
                            return `<span class="label label-lg label-info" data-id="${row.id}">${row[`total${type}`]}</span>`
                        }
                    },
                    {
                        field: '', title: 'Actions', sortable: false, textAlign: 'center', width: 50,
                        template: function (row) {
                            return `<span data-toggle="tooltip" data-original-title="Click here to upload" role="button" class="btn-upload-document" data-id="${row.id}" >
                                                            <i class="fas fa-upload text-primary icon-lg"></i>
                                                        </span>`
                        }
                    },
                ],
                detail: { content: callback }
            })
        }
        bindRegulatoryFirmsGrid('RegulatoryDocument', regulatoryDatatable);
        $(document).on("click", ".btn-upload-document", function () {
            KTApp.blockPage({ overlayColor: '#000000', state: 'primary', message: 'Please wait...' });
            var id = $(this).attr("data-id");
            loadPartialView(`adviser/home/regulatorydocumentmodal?firmId=${id}`, "RegulatoryDocumentUploadModal", null, function () {
                KTApp.unblockPage();
                $("#RegulatoryDocumentUploadModal").modal({ backdrop: 'static' });
            });
        });
        $(document).on("click", ".btn-regulatory-delete", function (e) {
            e.preventDefault()
            var cur = this;
            var swalOptions = confimationSwalOptions;
            Swal.fire(swalOptions)
                .then(function (result) {
                    if (result.value) {
                        var guid = $(cur).attr("data-guid");
                        deleteRecord(`adviser/home/deleteRegulatory?guid=${guid}`, function (response) {
                            KTApp.blockPage({ overlayColor: '#000000', state: 'primary', message: 'Please wait...' });
                            if (window['sub_datatable_' + response.parentId] != undefined)
                                window['sub_datatable_' + response.parentId].reload();
                            var el = $(`#firm_list [data-field='total'] .label-info[data-id='${response.parentId}']`);
                            el.text(response.data.ragulatoryCount);
                            setTimeout(function () { KTApp.unblockPage(); }, 1000);
                        });
                    }
                });
        });
    </script>
}